<?php
/*
addon_movepost2.php : administration file for miniBB 2.
This file is part of miniBB. miniBB is free discussion forums/message board software, without any warranty. See COPYING file for more details. Copyright (C) 2004-2006 Paul Puzyrev. www.minibb.net
Latest File Update: 2007-May-29
*/
if (!defined('INCLUDED776')) die ('Fatal error.');

$fName=$pathToFiles.'lang/movepost_'.$lang.'.php';
if(file_exists($fName)) include($fName); else include($pathToFiles.'lang/movepost_eng.php');
if($action=='vthread' or $action=='delAvatarAdmin') return;

if($user_id==1 or $isMod==1){

$title.=$l_movePost;
echo load_header();

echo '<table class="forumsmb"><tr><td style="padding-left:10px;padding-top:10px;padding-bottom:10px;">';

if(isset($_POST['step'])){

$topicid=(isset($_POST['topicid'])?$_POST['topicid']+0:0);
$postid=(isset($_POST['postid'])?$_POST['postid']+0:0);
$topictitle=(isset($_POST['topictitle'])?trim($_POST['topictitle']):'');
$forum_id=(isset($_POST['forum_id'])?$_POST['forum_id']+0:0);
$movedMsgs=(isset($_POST['movedMsgs'])?explode(',',$_POST['movedMsgs']):array($postid));

$checkPost=$movedMsgs[0];

$err1=($forum_id!=0 and $checkPost!=0 and $rs=db_simpleSelect(0,$Tp,'topic_id, poster_id, poster_name, post_time, poster_ip','post_id','=',$checkPost));

/* determine old page */
$oldtopicid=$rs[0];
if(isset($themeDesc) and in_array($oldtopicid,$themeDesc)) $vv=TRUE; else $vv=FALSE;
if(!$vv) $sg='<'; else $sg='>';
if($row=db_simpleSelect(0, $Tp, 'count(*)', 'post_id', $sg, $checkPost, '', '', 'topic_id', '=', $oldtopicid)) $pt=$row[0]; else $pt=0;
if($pt<=$viewmaxreplys) $oldPage=0; else $oldPage=(integer)($pt/$viewmaxreplys);


if($topictitle!='' and !$err1){
$errorMSG='<span class=txtNr>'.$l_moveWarn.'</span>';
echo ParseTpl(makeUp('main_warning'));
}

else{

if($topictitle!='' and $err1){
/* Create new topic here */

include($pathToFiles.'bb_func_txt.php');
$topictitle=str_replace(array('&#032;', '&#32;'), '', $topictitle);
$topic_title=textFilter($topictitle,$topic_max_length,$post_word_maxlength,0,1,0,$user_id,255);

$topic_poster=$rs[1];
$topic_poster_name=$rs[2];
$topic_time=$rs[3];
$topic_views=0;
$topic_status=0;
$topic_last_post_id=max($movedMsgs);
$posts_count=0;
$sticky=0;
$topic_last_post_time=$rs[3];

insertArray(array('topic_title', 'topic_poster', 'topic_poster_name', 'topic_time', 'topic_views', 'forum_id', 'topic_status', 'topic_last_post_id', 'posts_count', 'sticky', 'topic_last_post_time'), $Tt);
$topicid=$insres;
}

if($rs2=db_simpleSelect(0,$Tt,'topic_id','topic_id','=',$topicid)){

/* Post and topic exist, now we move */

$currtop=$rs[0];

foreach($movedMsgs as $postid){

clearstatcache();

/* file upload addon handling */
if(file_exists($pathToFiles.'addon_fileupload_options.php')) include($pathToFiles.'addon_fileupload_options.php');
if(isset($dirsTopic) and $dirsTopic) {
$moveDir=$uploadDir.'/uploaded'.'/'.$currtop;
$moveDir2=$uploadDir.'/uploaded'.'/'.$topicid;
$filesFound=0;
$filesRenamed=0;
if(is_dir($moveDir)){
if ($handle = opendir($moveDir)) {
while (false !== ($file = readdir($handle))) {
if ($file != '.' and $file != '..') {
$filesFound++;
$rn=explode('_', $file);
if($rn[0]==$postid){
if(!is_dir($moveDir2)) {
umask(0);
if(!mkdir($moveDir2,0777)) die('Can not create separate topic directory.');
}
rename($moveDir.'/'.$file, $moveDir2.'/'.$file);
$filesRenamed++;
}
}
}
}
closedir($handle);
}
if($filesFound==$filesRenamed and is_dir($moveDir)) rmdir($moveDir);
}
/* --file upload addon handling */

}

$tot=0;
$fornew=db_simpleSelect(0,$Tt,'forum_id','topic_id','=',$topicid); $fornew=$fornew[0];
$forold=db_simpleSelect(0,$Tt,'forum_id','topic_id','=',$currtop); $forold=$forold[0];

$topic_id=$topicid;
foreach($movedMsgs as $postid) $tot+=updateArray(array('topic_id'),$Tp,'post_id',$postid);

$forum_id=$fornew;
foreach($movedMsgs as $postid) $tot+=updateArray(array('forum_id'),$Tp,'post_id',$postid);

/* Check if it was the only one post in the topic, delete the whole topic then! */
$oldCnt=db_simpleSelect(0,$Tp,'count(*)','topic_id','=',$currtop); $oldCnt=$oldCnt[0];
if($oldCnt==0) {
db_delete($Tt,'topic_id','=',$currtop);
db_calcAmount($Tt,'forum_id',$forold,$Tf,'posts_count');
}
else {
/* Max stuff */

if($rs=db_simpleSelect(0,$Tp,'post_id, post_time, poster_name','topic_id','=',$currtop,$orderby='post_id DESC',1)){
$topic_last_post_id=$rs[0];
$topic_last_post_time=$rs[1];
$topic_last_poster=$rs[2];
$tot+=updateArray(array('topic_last_post_id', 'topic_last_post_time', 'topic_last_poster'),$Tt,'topic_id',$currtop);
}

}

if($rs=db_simpleSelect(0,$Tp,'post_id, post_time, poster_name','topic_id','=',$topicid,$orderby='post_id DESC',1)){
$topic_last_post_id=$rs[0];
$topic_last_post_time=$rs[1];
$topic_last_poster=$rs[2];
$tot+=updateArray(array('topic_last_post_id', 'topic_last_post_time', 'topic_last_poster'),$Tt,'topic_id',$topicid);
}

/* determine new page */
$minPost=min($movedMsgs);

if(isset($themeDesc) and in_array($topicid,$themeDesc)) $vv=TRUE; else $vv=FALSE;
if(!$vv) $sg='<='; else $sg='>=';
if($row=db_simpleSelect(0, $Tp, 'count(*)', 'post_id', $sg, $minPost, '', '', 'topic_id', '=', $topicid)) $pt=$row[0]; else $pt=0;
if($pt<=$viewmaxreplys) $newPage=0; else $newPage=(integer)($pt/$viewmaxreplys);


db_calcAmount($Tp,'forum_id',$fornew,$Tf,'posts_count');
db_calcAmount($Tp,'forum_id',$forold,$Tf,'posts_count');

db_calcAmount($Tt,'forum_id',$fornew,$Tf,'topics_count');
db_calcAmount($Tt,'forum_id',$forold,$Tf,'topics_count');

db_calcAmount($Tp,'topic_id',$currtop,$Tt,'posts_count');
db_calcAmount($Tp,'topic_id',$topicid,$Tt,'posts_count');

if(isset($mod_rewrite) and $mod_rewrite){
$urlp1="{$fornew}_{$topicid}_{$newPage}.html#msg{$minPost}"; $urlp2="{$forold}_{$currtop}_{$oldPage}.html";
}
else{
$urlp1="{$indexphp}action=vthread&amp;topic={$topicid}&amp;forum={$fornew}&amp;page={$newPage}#msg{$minPost}"; $urlp2="{$indexphp}action=vthread&amp;topic={$currtop}&amp;forum={$forold}&amp;page={$oldPage}";
}

echo "<span class=\"txtNr\">{$l_movedOk} {$tot}<br /><a href='{$main_url}/{$urlp1}'>{$l_viewMovedTopic}</a> / <a href='{$main_url}/{$urlp2}'>{$l_viewOldTopic}</a></span>";

if(sizeof($movedMsgs)>1){
echo "<script type=\"text/javascript\">window.opener.document.location=window.opener.document.location;</script>";
}

}
else {
$errorMSG='<span class="txtNr">'.$l_moveWarn.'</span>';
echo ParseTpl(makeUp('main_warning'));
}

}//topic title is not set

}

else{
$post=(isset($_GET['post'])?$_GET['post']+0:'');
$forum=(isset($_GET['forum'])?$_GET['forum']+0:'0');

if(isset($_GET['forum'])) $forum=$_GET['forum']+0; elseif(isset($_POST['forum'])) $forum=$_POST['forum']+0; else $forum=0;

if(isset($_POST['deleteAll']) and is_array($_POST['deleteAll']) and sizeof($_POST['deleteAll'])>1){
//mass moving
$whatToMove='<span class="txtNr"><strong>'.$l_moveArray.' ['.sizeof($_POST['deleteAll']).']</strong></span><br />';
$whatToMove.='<input type="hidden" name="movedMsgs" value="'.implode(',', $_POST['deleteAll']).'" />';
}
else{
$whatToMove=<<<out
<span class="txtNr"><input type="text" name="postid" size="6" maxlength="10" class="textForm" value="{$post}" readonly="readonly" /><br />{$l_postId}<br /></span>
out;
}

$frm=0;
include($pathToFiles.'bb_func_forums.php');

echo <<<out
<form action="{$indexphp}" method="post">
{$whatToMove}
<br />
<span class="txtNr"><input type="text" name="topicid" size="6" maxlength="10" class="textForm" /><br />{$l_topicId}<br /></span>
<br />
<span class="txtNr"><input type="text" name="topictitle" size="38" maxlength="{$topic_max_length}" class="textForm" style="width:450px;" /><br />{$l_newTopicMove}
<br /><br />
<select name="forum_id" class="textForm">
{$listForums}
</select>
<br />{$l_moveForum}</span>
<br /><br />
<input type="hidden" name="action" value="movepost" />
<input type="hidden" name="forum" value="{$forum}" />
<input type="hidden" name="step" value="2" />
<input type="submit" value="{$l_movePost}" class="textForm" />
</form>
out;
}


echo '</td></tr></table>';
}

?>