<?php
/*
addon_monthusers.php : statistics file for miniBB 2 (most active users in a given month incl. admin).
This file is part of miniBB. miniBB is free discussion forums/message board software, without any warranty. See COPYING file for more details. Copyright (C) 2005-2006 Paul Puzyrev. www.minibb.net
Latest File Update: 2006-Dec-18
*/
if (!defined('INCLUDED776')) die ('Fatal error.');

if(isset($_GET['statMonth'])) $statMonth=abs($_GET['statMonth']+0); else $statMonth=1;
if(isset($_GET['statYear'])) $statYear=abs($_GET['statYear']+0); else $statYear=date('Y');
if(isset($_GET['limits'])) $limits=abs($_GET['limits']+0); else $limits=10;
if($limits>100) $limits=100;

$fName=$pathToFiles.'lang/monthusers_'.$lang.'.php';
if(file_exists($fName)) include($fName); else include($pathToFiles.'lang/monthusers_eng.php');

$title.=$l_mStatsUsers;
if($action=='monthusers') echo load_header();

/*
//if($user_id==0){ //only for registered members
if(!($user_id==1 or $isMod)){ //only for admin/mods
echo '<div align=center><table class=forums><tr><td class=caption3>Not available for you, sorry!</td></tr></table>';
return;
}
*/

$mnt=explode(':',$l_months);
for($i=0;$i<12;$i++) $months[$i+1]=$mnt[$i];
$monthsDropDown=makeValuedDropDown($months,'statMonth');

if($row=db_simpleSelect(0,$Tp,'post_time','','','','post_id asc',1)) $minYear=date('Y',strtotime($row[0]));
else $minYear=date('Y');

$years=array();
for($i=$minYear;$i<=date('Y');$i++) $years[$i]=$i;

$yearsDropDown=makeValuedDropDown($years,'statYear');

$limitsDropDown=makeValuedDropDown(array(5=>5,10=>10,20=>20,50=>50,100=>100),'limits');

$userBoxes = <<<out
<form class="formStyle" method="get" action="{$main_url}/{$indexphp}">
<table class="forumsmb">

<tr><td class="caption3">
<span class="txtNr">{$l_chooseMonth}<br />{$monthsDropDown}&nbsp;{$yearsDropDown}&nbsp;{$l_stats_top}&nbsp;{$limitsDropDown}</span>
<input type="submit" value="{$l_submit}" class="inputButton" />
<input type="hidden" name="step" value="1" />
<input type="hidden" name="action" value="monthusers" />

</td></tr>
</table>
</form>
out;

if($action=='monthusers') echo <<<out

<table class="forumsmb">
<tr>
<td class="caption3"><span class="txtNr"><strong><a href="{$main_url}/{$indexphp}">{$sitename}</a></strong> / <strong>{$l_mStatsUsers}</strong></span></td>
</tr>
</table>

{$userBoxes}
out;

if(isset($_GET['step'])){

$tpl=makeUp('stats_bar');
$list_stats_aUsers='';

if($statMonth<10) $statMonth='0'.$statMonth;
$startDate="{$statYear}-{$statMonth}-01 00:00:00";
$endDate="{$statYear}-{$statMonth}-31 23:59:59";

if($res=mysql_query("select poster_id, poster_name, count(*) as pcount from $Tp where poster_id!=0 and post_time>='{$startDate}' and post_time<='{$endDate}' group by poster_id order by pcount desc limit {$limits}") and mysql_num_rows($res)>0 and $cols=mysql_fetch_row($res)){

echo '<table class="forumsmb"><tr><td>';

do{
$val=$cols[2];
if(!isset($vMax)) $vMax=$val;
$stats_barWidth=round(100*($val/$vMax));
if($stats_barWidth>$stats_barWidthLim) $key='<a href="'.$indexphp.'action=userinfo&amp;user='.$cols[0].'">'.$cols[1].'</a>';
else{
$key2='<a href="'.$indexphp.'action=userinfo&amp;user='.$cols[0].'">'.$cols[1].'</a>';
$key='<a href="'.$indexphp.'action=userinfo&amp;user='.$cols[0].'">...</a>';
}
$list_stats_aUsers.=ParseTpl($tpl);
}
while($cols=mysql_fetch_row($res));
}

echo $list_stats_aUsers.'</td></tr></table>';

}

return;
?>