<?php
/*
This file is part of miniBB. miniBB is free discussion forums/message board software, without any warranty. See COPYING file for more details. Copyright (C) 2004-2006 Paul Puzyrev, Sergei Larionov. www.minibb.net
Latest File Update: 2006-Apr-13
*/

// Настройки

$DBhost='localhost'; // Хост
$DBname='minibb';   // Имя базы
$DBusr='root';      // Имя Пользователя
$DBpwd='';          // Пароль
$DBch='utf8';      // Кодировка
$DB='mysql';       // База Данных

// Данные Админа
$admin_usr='Admin';
$admin_pwd='1234';
$admin_email='admin@'.$_SERVER['HTTP_HOST'];

// URL Форума
$main_url='http://'.$_SERVER['HTTP_HOST'].'/minibb_full';

$lang='rus';   // Язык
$skin='default'; // Скин (aspirine, computers, dashed, default, greyblack, ledge, ledge2, light, smartdark, white, xmini)
// Заголовок
$sitename= 'Форум '.$_SERVER['HTTP_HOST'];

// Разрешенные символы в нике (А-Яа-я лучше не использовать)
$userRegName='A-Za-z0-9 абвгдеёжзийклмнопрстуфхцчшщьыъэюя_АБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЬЫЪЭЮЯ';

// Имена таблиц
$Tf='minibbtable_forums';
$Tp='minibbtable_posts';
$Tt='minibbtable_topics';
$Tu='minibbtable_users';
$Ts='minibbtable_send_mails';
$Tb='minibbtable_banned';


// Админка
$bb_admin='bb_admin.php?';


$emailadmin=0;
$emailusers=0;
$emailCharset='utf-8'; // Кодировка E-mail
$l_sepr='-';

$post_text_maxlength=10240;
$post_word_maxlength=85;
$topic_max_length=100;
$viewmaxtopic=30;
$viewlastdiscussions=30;
$viewmaxreplys=30;
$viewmaxsearch=30;
$viewpagelim=5000;
$viewTopicsIfOnlyOneForum=0;

$protectWholeForum=0;
$protectWholeForumPwd='pwd';

$postRange=30; // Пауза между сообщениями

$dateFormat='j F Y H:i';

$cookiedomain='';
$cookiename='miniBBsite';
$cookiepath='';
$cookiesecure=FALSE;
$cookie_expires=108000;
$cookie_renew=1800;
$cookielang_exp=2592000;

/* New options for miniBB 1.1 */

$disallowNames=array('Anonymous', 'Fuck', 'Shit');
//$disallowNamesIndex=array('admin'); // 2.0 RC1f

/* New options for miniBB 1.2 */
$sortingTopics=0;
$topStats=4;
$genEmailDisable=0;

/* New options for miniBB 1.3 */
$defDays=60;
$userUnlock=0;

/* New options for miniBB 1.5 */
$emailadmposts=0;
$useredit=86400;

/* New options for miniBB 1.6 */
//$metaLocation='go';
//$closeRegister=1;
//$timeDiff=21600;

/* New options for miniBB 1.7 */
$stats_barWidthLim='31';

/* New options for miniBB 2.0 */

$dbUserSheme=array(
'username'=>array(1,'username','login'),
'user_password'=>array(3,'user_password','passwd'),
'user_email'=>array(4,'user_email','email'),
'user_icq'=>array(5,'user_icq','icq'),
'user_website'=>array(6,'user_website','website'),
'user_occ'=>array(7,'user_occ','occupation'),
'user_from'=>array(8,'user_from','from'),
'user_interest'=>array(9,'user_interest','interest'),
'user_viewemail'=>array(10,'user_viewemail','user_viewemail'),
'user_sorttopics'=>array(11,'user_sorttopics','user_sorttopics'),
'language'=>array(14,'language','language'),
'num_topics'=>array(16,'num_topics',''),
'num_posts'=>array(17,'num_posts',''),
'user_custom1'=>array(18,'user_custom1','user_custom1'),
'user_custom2'=>array(19,'user_custom2','user_custom2'),
'user_custom3'=>array(20,'user_custom3','user_custom3')
);
$dbUserId='user_id';
$dbUserDate='user_regdate'; $dbUserDateKey=2;
$dbUserAct='activity';
$dbUserNp='user_newpasswd';
$dbUserNk='user_newpwdkey';

$enableNewRegistrations=TRUE;
$enableProfileUpdate=TRUE;

$indexphp='index.php?';
$useSessions=FALSE;
$usersEditTopicTitle=FALSE;
$pathToFiles='./';
//$includeHeader='header.php';
//$includeFooter='footer.php';
//$emptySubscribe=TRUE;
//$allForumsReg=TRUE;
//$registerInactiveUsers=TRUE;
//$mod_rewrite=TRUE;
$enableViews=TRUE;


$userInfoInPosts=array('user_custom1',$dbUserSheme['user_custom2'][1],'user_custom3');


$userDeleteMsgs=1;

// Описание
$description='Forum miniBB mod by Gemorroj';
$title_forum = '<span style="color:#8FBEE8;font-size:22px;padding-top:3px;padding-bottom:1px;padding-left:3px;font-weight:bold;">Форум</span><span style="color:#006699;font-size:22px;padding-top:3px;padding-bottom:1px;padding-left:5px;">'.$_SERVER['HTTP_HOST'].'</span>';

$startIndex='index.php';
$manualIndex='index.php?action=manual';

//$enableGroupMsgDelete=TRUE;
$post_text_minlength=2;
$loginsCase=TRUE;

$allowHyperlinks=0;

$reply_to_email=$admin_email;

//$addMainTitle=1;
?>